@echo off
color 0a
title Aoto Deploy Project 1.0
pushd "%~dp0"

SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION

set QUICK_MODE=true
if /i "%QUICK_MODE%" equ "true" (
	set /a NS_CHOICE=0
) else (
	set /a NS_CHOICE=3
)

set FILE_NAME=%~n0

set CONFIG=%~1
if "%CONFIG%" equ "" (
	set CONFIG=conf\%~n0.ini
)

call :FN_IS_FILE "%CONFIG%"
if "%RTN%" equ "false" (
	echo Invalid 'CONFIG'.
	goto :ERROR_EXIT
)

for /f "usebackq eol=# tokens=1* delims==" %%i in ("%CONFIG%") do (
	set %%i=%%~j
)
call :FN_FQPN MWF_PATH MWF_INI WAR_FILE XML_PATH

if "%XML_PATH%" equ "" (
	call :FN_FILENAME "%CONFIG%"
	call :FN_TO_CANONICAL_PATH "%CONFIG%\..\!RTN!.xml"
	set XML_PATH=!RTN!
)
call :FN_IS_FILE "%XML_PATH%"
if "%RTN%" equ "false" (
	echo Invalid 'XML_PATH'.
	goto :ERROR_EXIT
)

if "%MWF_PATH%" neq "" (
	call :FN_IS_FILE "%MWF_PATH%"
	if "!RTN!" equ "true" (
		if "%MWF_INI%" neq "" (
			call :FN_IS_FILE "%MWF_INI%"
			if "!RTN!" equ "false" (
				echo Invalid 'MWF_INI'.
				goto :ERROR_EXIT
			)
		)
		echo Start application ^('MWF'^) and wait for it to terminate.
		echo Note: It is best to exit normally.
		echo.
		call :FN_TO_FPNSN "%MWF_PATH%"
		set SN_MWF_APP=!RTN!
		call :FN_TO_FPNSN "%MWF_INI%"
		set SN_MWF_INI=!RTN!
		START "MWF" /I /WAIT !SN_MWF_APP! !SN_MWF_INI!
	) else (
		echo Invalid 'MWF_PATH'.
		goto :ERROR_EXIT
	)
)

echo CONFIG -^> %CONFIG%
echo MWF_PATH -^> %MWF_PATH%
echo MWF_INI -^> %MWF_INI%
echo WAR_FILE -^> %WAR_FILE%
echo XML_PATH -^> %XML_PATH%

echo.
choice /c yN /cs /t %NS_CHOICE% /d y /m "Upload now?"

if %ERRORLEVEL% neq 1 (
	echo You gave up the upload.
	goto :NORMAL_EXIT
)

for /f "tokens=*" %%i in ("%WAR_FILE%") do (
	set WAR_FILE=%%~fi
	if "%%~xi" equ ".war" (
		if not exist "%WAR_FILE%\" (
			if exist "%WAR_FILE%" (
				goto :LOGIN
			)
		)
	)
)
echo Not a WAR file. '%WAR_FILE%'
goto :ERROR_EXIT

:LOGIN
rem Work directory
set WORK_DIR=work
if exist "%WORK_DIR%\" (
	rmdir /s /q "%WORK_DIR%"
)
if exist "%WORK_DIR%" (
	del /f /q /a "%WORK_DIR%"
)
mkdir "%WORK_DIR%"
cd . > "%WORK_DIR%\%FILE_NAME%.tmp"
cd . > "%WORK_DIR%\%FILE_NAME%.sf"
>> "%WORK_DIR%\%FILE_NAME%.sf" echo bell
>> "%WORK_DIR%\%FILE_NAME%.sf" echo open %HOST%
>> "%WORK_DIR%\%FILE_NAME%.sf" echo user %USERNAME% %PASSWORD%
>> "%WORK_DIR%\%FILE_NAME%.sf" echo binary
>> "%WORK_DIR%\%FILE_NAME%.sf" echo put "%WORK_DIR%\%FILE_NAME%.tmp"
>> "%WORK_DIR%\%FILE_NAME%.sf" echo get "%FILE_NAME%.tmp" "%WORK_DIR%\%FILE_NAME%.bin"
>> "%WORK_DIR%\%FILE_NAME%.sf" echo delete "%FILE_NAME%.tmp"
>> "%WORK_DIR%\%FILE_NAME%.sf" echo put "%WAR_FILE%"
>> "%WORK_DIR%\%FILE_NAME%.sf" echo quit

ftp -n -s:"%WORK_DIR%\%FILE_NAME%.sf"
del "%WORK_DIR%\%FILE_NAME%.sf"
del "%WORK_DIR%\%FILE_NAME%.tmp"
if not exist "%WORK_DIR%\%FILE_NAME%.bin" (
	echo Login failed.
	rmdir /s /q "%WORK_DIR%"
	goto :ERROR_EXIT
)
rmdir /s /q "%WORK_DIR%"

echo.
set /a REQ_COUNT=0
choice /c yN /cs /t %NS_CHOICE% /d y /m "Request now?"
if %ERRORLEVEL% neq 1 (
	echo You gave up the request.
	goto :NORMAL_EXIT
)

:PROC_REQUEST
set /a REQ_COUNT+=1
set /a RESULT=-1
echo.
echo Number of requests: %REQ_COUNT%
for /f "usebackq tokens=*" %%x in (`cscript "%FILE_NAME%.vbs" "%XML_PATH%" %CACHE% %URL%`) do (
	echo %%x
	if "%%x" equ "*Request.CreateScriptFile.Completed*" (
		set /a RESULT=0
	)
)
if %RESULT% neq 0 (
	choice /c yN /cs /t %NS_CHOICE% /d y /m "Request failed, try again now?"
	if !ERRORLEVEL! neq 1 (
		echo You gave up the request.
		goto :NORMAL_EXIT
	)
	ping /n 2 127.0.0.1 > nul
	goto :PROC_REQUEST
)
echo.
echo The command completed successfully.
goto :NORMAL_EXIT

:NORMAL_EXIT
popd
choice /t %NS_CHOICE% /c O /cs /d O /n
exit

:ERROR_EXIT
pause
exit

@rem ##############################FBP Begin
rem to a fully qualified path name
rem eg. call :FN_FQPN XML_PATH INI_PATH
:FN_FQPN
if "%~1" equ "" goto :EOF
for /f "tokens=*" %%i in ("!%~1!") do (
	set %~1=%%~fi
)
shift
goto :FN_FQPN



rem eg. call :FN_IS_DIR "C:\MyDir\"
:FN_IS_DIR
call :FN_TO_CANONICAL_PATH "%~1"
if "%RTN%" equ "" (
	set RTN=false
	goto :EOF
)
if exist "%RTN%\" (
	set RTN=true
	goto :EOF
)
set RTN=false
goto :EOF



rem eg. call :FN_IS_FILE "C:\MyFile"
:FN_IS_FILE
call :FN_TO_CANONICAL_PATH "%~1"
if "%RTN%" equ "" (
	set RTN=false
	goto :EOF
)
if not exist "%RTN%\" (
	set RTN=true
	goto :EOF
)
set RTN=false
goto :EOF



rem eg. call :FN_TO_CANONICAL_PATH .
rem \\ -> network path
rem end with \, means it is a directory.
:FN_TO_CANONICAL_PATH
for /f "tokens=*" %%i in ("%~1") do (
	set RTN=%%~fi
	if exist "!RTN!\" (
		pushd "!RTN!\"
		set RTN=!CD!
		popd
	) else if not exist "!RTN!" (
		set RTN=
	)
)
goto :EOF



rem eg. call :FN_SELF_NAME .
:FN_SELF_NAME
call :FN_TO_CANONICAL_PATH "%~1"
if "%RTN%" equ "" (
	set RTN=
	goto :EOF
)
for /f "tokens=*" %%i in ("%RTN%") do (
	set RTN=%%~nxi
)
goto :EOF



rem eg. call :FN_PARENT_NAME .
:FN_PARENT_NAME
call :FN_SELF_NAME "%~1\.."
goto :EOF



rem eg. call :FN_FILENAME "test.txt"
rem Please follow the 'for' command rule.
:FN_FILENAME
set RTN=%~n1
goto :EOF



rem to a full path name with short names only.
rem eg. call :FN_TO_FPNSN "C:\Program Files (x86)\Windows NT"
rem RTN  --> C:\PROGRA~2\WINDOW~2
:FN_TO_FPNSN
set RTN=%~fs1
goto :EOF
@rem ##############################FBP End
